#include "Entity.h"

namespace armarx::armem::ltm
{

    wm::Entity Entity::convert() const
    {
        wm::Entity m;
        for (const auto& [_, s] : _container)
        {
            m.addSnapshot(s.convert());
        }
        return m;
    }

    void Entity::append(const wm::Entity& m)
    {
        for (const auto& [k, s] : m.container())
        {
            if (const auto& it = _container.find(k); it != _container.end())
            {
                it->second.setTo(s);
            }
            else
            {
                auto wms = _container.emplace(std::make_pair(k, id().withTimestamp(k)));
                wms.first->second.setTo(s);
            }
        }
    }
}
