#include <RobotAPI/libraries/armem/client/WriterComponentPlugin.h>


// ArmarX
#include <ArmarXCore/core/exceptions/local/ExpressionException.h>

// RobotAPI
#include <RobotAPI/libraries/armem/core/error.h>


namespace armarx::armem::client::plugins
{
    WriterComponentPlugin::~WriterComponentPlugin()
    {
        // pass
    }
}


namespace armarx::armem::client
{
    WriterComponentPluginUser::WriterComponentPluginUser()
    {
        addPlugin(plugin);
    }


    WriterComponentPluginUser::~WriterComponentPluginUser()
    {
        // pass
    }


    void
    WriterComponentPluginUser::setWritingMemory(server::WritingMemoryInterfacePrx memory)
    {
        memoryWriter.setWritingMemory(memory);
    }

    armem::data::WaitForMemoryResult WriterComponentPluginUser::useMemory(const std::string& memoryName)
    {
        armem::data::WaitForMemoryResult result = mns::plugins::ClientPluginUserBase::useMemory(memoryName);
        if (result.proxy)
        {
            setWritingMemory(result.proxy);
        }
        return result;
    }
}

