#pragma once

#include <RobotAPI/libraries/ArmarXObjects/ObjectPose.h>

#include <RobotAPI/libraries/armem_objects/aron/ObjectInstance.aron.generated.h>


#include <RobotAPI/libraries/armem_objects/types.h>

#include <RobotAPI/libraries/armem_objects/aron/RobotDescription.aron.generated.h>
#include <RobotAPI/libraries/armem_objects/aron/RobotState.aron.generated.h>
#include <RobotAPI/libraries/armem_objects/aron/Robot.aron.generated.h>

namespace armarx::armem
{
    void fromAron(const arondto::ObjectInstance& dto, objpose::arondto::ObjectPose& bo);
    void toAron(arondto::ObjectInstance& dto, const objpose::arondto::ObjectPose& bo);

    void fromAron(const arondto::ObjectInstance& dto, objpose::ObjectPose& bo);
    void toAron(arondto::ObjectInstance& dto, const objpose::ObjectPose& bo);


    // TODO move the following
    void fromAron(const long& dto, IceUtil::Time& time);
    void toAron(long& dto, const IceUtil::Time& time);
    // end TODO


    void fromAron(const arondto::Robot& dto, Robot& bo);
    void toAron(arondto::Robot& dto, const Robot& bo);

    void fromAron(const arondto::RobotDescription& dto, RobotDescription& bo);
    void toAron(arondto::RobotDescription& dto, const RobotDescription& bo);

    void fromAron(const arondto::RobotState& dto, RobotState& bo);
    void toAron(arondto::RobotState& dto, const RobotState& bo);

}  // namespace armarx::armem
